// FILENAME:	Complexity.cs
//
// AUTHOR:  	Maj. DarkRaven [M.I.B.]
//------------------------------------------------------------------------------

$missionName = "Complexity";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;
}

function onMissionStart()
{
	// Keep tracks of hercs near a door
	$HercsAtDoor1 = 0;
	$HercsAtDoor2 = 0;

	$healRate = 150;
	$ammoRate = 5;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;

	europaSounds();
}

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to DeathMatch Complexity! You can download this & other missions made by Maj. DarkRaven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
}

function onMissionLoad()
{
   cdAudioCycle("watching", "mechsoul", "terror");
}

// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true);
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true);
}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);
}
function ZenAll::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true);
}

//door functionality
//--------------------------------------------------------------------------------
function door1::trigger::onEnter(%this, %vehicleId){
	if($hercsAtDoor1 == 0){
		playAnimSequence(getObjectId("MissionGroup\\Stuff\\Door1"), 0, true);
	}
	$hercsAtDoor1 = $hercsAtDoor1 + 1;
}
function door1::trigger::onLeave(%this, %vehicleId){
	$hercsAtDoor1 = $hercsAtDoor1 - 1;
	if($hercsAtDoor1 == 0){
		playAnimSequence(getObjectId("MissionGroup\\Stuff\\Door1"), 0, false);
	}
}
function door2::trigger::onEnter(%this, %vehicleId){
	if($hercsAtDoor2 == 0){
		playAnimSequence(getObjectId("MissionGroup\\Stuff\\Door2"), 0, true);
	}
	$hercsAtDoor2 = $hercsAtDoor2 + 1;
}
function door2::trigger::onLeave(%this, %vehicleId){
	$hercsAtDoor2 = $hercsAtDoor2 - 1;
	if($hercsAtDoor2 == 0){
		playAnimSequence(getObjectId("MissionGroup\\Stuff\\Door2"), 0, false);
	}
}
// transporters
function neartransport(%this, %object) // randomly transports player to anywhere
within 150 meters of current position
{
	getposition(%this, %x, %y, %z);
	%xhuh = randomInt(-150, 150);
	%yhuh = randomInt(-150, 150);
	%zhuh = RandomInt(50, 300);
	setposition(%object, %x + %xhuh, %y + %yhuh, %z + %zhuh);
}
function randomtrans(%this, %object)
{
	randomtransport(%object, -600, -600, 600, 600);
	schedule("getposition(%object, %x, %y, %z);", 0.5);
	setposition(%object, %x, %y, %z + 3000);
}

function transto::trigger::oncontact(%this, %object)
{
	setposition(%object, 0, 0, 4950);
}
function transfrom::trigger::oncontact(%this, %object)
{
	setposition(%object, 100, 100, 700);
}
// this is hard to find, a teleporter takes you here(that in itself is hard...)
and the 4 more inside take you out, if you want to, one teleporter per base, but
you wont know which goes to which base...
function myne::trigger::oncontact(%this, %object)
{
	setposition(%object, 0, 0, -2000);
}
function telered::trigger::oncontact(%this, %object)
{
	setposition(%object, 100, 100, 500);
}
function teleblue::trigger::oncontact(%this, %object)
{
	setposition(%object, 100, 100, 500);
}
function teleyellow::trigger::oncontact(%this, %object)
{
	setposition(%object, 100, 100, 500);
}
function telepurple::trigger::oncontact(%this, %object)
{
	setposition(%object, 100, 100, 500);
}

