// FILENAME:	CTF_Mercury_Hill.cs
//
// AUTHORS:	~Miss Daisy~ ^WP^*
//------------------------------------------------------------------------------

$missionName = "CTF_Mercury_Hill";

$maxFlagCount  = 5;           // no of flags required by a team to end the game
$flagValue     = 5;          // points your team gets for capturing
$carrierValue  = 2;          //  "      "    "    "    " killing carrier
$killPoints    = 1;
$deathPoints   = 1;
$flagTime = 300;

exec("multiplayerStdLib.cs");
exec("CTFstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = true;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = false;
}

function onMissionLoad()
{
   cdAudioCycle("Purge", "Terror", "Watching");
}

function onMissionStart()
{
	initGlobalVars();

	
	$lastVehicleOnZen = "";
	$lastVehicleOnRedZen = "";
	$lastVehicleOnBlueZen = "";
	$secondsToGain = 0;
	$secondsToGainRedZen = 0;
	$secondsToGainBlueZen = 0;
	  
	mercurySounds();
}

// move the map
$server::HudMapViewOffsetX = -2950;
$server::HudMapViewOffsetY = -8130;

//function BlueDamage::trigger::onContact(%this, %object)
//{
//	%player = playerManager::vehicleIdToPlayerNum(%vehicle);	
//	damageObject(%object, 200);
//	say(%player, 0, "<F5>WARNING!! FLAG DAMAGE!!");
//}
// function PurpleDamage::trigger::onContact(%this, %object)
//{
//	%player = playerManager::vehicleIdToPlayerNum(%vehicle);	
//	damageObject(%object, 200);
//	say(%player, 0, "<F5>WARNING!! FLAG DAMAGE!!");
//}

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function RedZen::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function RedZen::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $redZenHealRate, $redZenAmmoRate, $zenWaitTime, true);
	if(isShutDown(%object)){
		if(%object != $lastVehicleOnRedZen){
			$lastVehicleOnRedZen = %object;
			$secondsToGainRedZen = 1;
		}
		else{
			$secondsToGainRedZen = $secondsToGainRedZen + 1;
		}
		if($secondsToGainRedZen >= 4)
			giveRedTurretsToThisGuy(%object);
	}
}
// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function BlueZen::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}
function BlueZen::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $blueZenHealRate, $blueZenAmmoRate, $zenWaitTime, true);
	if(isShutDown(%object)){
		if(%object != $lastVehicleOnBlueZen){
			$lastVehicleOnBlueZen = %object;
			$secondsToGainBlueZen = 1;
		}
		else{
			$secondsToGainBlueZen = $secondsToGainBlueZen + 1;
		}
		if($secondsToGainBlueZen >= 4)
			giveBlueTurretsToThisGuy(%object);
	}
}

// Turret Code
// -----------------------------------------------------------------------------------

function giveRedTurretsToThisGuy(%vehicleId){
	%team = getTeam(%vehicleId);
	setTeam("MissionGroup\\CenterStructures\\T5", %team);
	setTeam("MissionGroup\\CenterStructures\\T6", %team);
	setTeam("MissionGroup\\CenterStructures\\NavZenRed", %team);
	order("MissionGroup\\CenterStructures", Shutdown, false);	
}
function giveBlueTurretsToThisGuy(%vehicleId){
	%team = getTeam(%vehicleId);
	setTeam("MissionGroup\\CenterStructures\\T7", %team);
	setTeam("MissionGroup\\CenterStructures\\T8", %team);
	setTeam("MissionGroup\\CenterStructures\\NavZenBlue", %team);
	order("MissionGroup\\CenterStructures", Shutdown, false);	
}

//%player = playerManager::vehicleIdToPlayerNum(%vehicle); 
//
//damageObject(%vehicle, 100000); 
//
//say(%player, 0, "This teleporter is for the YELLOW TEAM ONLY!"); 
